
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:google_mobile_ads/google_mobile_ads.dart';
import 'package:ourads/models/ad_id_interface.dart';

class OurBanner extends StatefulWidget {
  final double width;
  final double height;

  OurBanner({
    required this.width,
    required this.height,
  });

  @override
  _OurBannerState createState() => _OurBannerState();
}

class _OurBannerState extends State<OurBanner> {
  bool adLoaded = false;
  late BannerAd banner;

  AdIdInterface get _adId {
    try {
      final tempAdInterface = Get.find<AdIdInterface>();
      return tempAdInterface;
    } catch (e) {
      throw Exception(
        'You did not initialised the object. Please init the object in main function',
      );
    }
  }

  @override
  void initState() {
    super.initState();
    banner = BannerAd(
      adUnitId: _adId.bannerId,
      size: AdSize.banner,
      request: AdRequest(),
      listener: BannerAdListener(onAdLoaded: (ad) {
        setState(() {
          adLoaded = true;
        });
      }),
    );
    banner.load();
  }

  @override
  Widget build(BuildContext context) {
    return adLoaded
        ? Container(
            width: widget.width,
            height: widget.height,
            child: AdWidget(
              ad: banner,
            ),
          )
        : SizedBox();
  }

  @override
  void dispose() {
    banner.dispose();
    super.dispose();
  }
}
